Index: lib/TWiki.pm
===================================================================
--- lib/TWiki.pm	(revision 1767)
+++ lib/TWiki.pm	(working copy)
@@ -478,292 +627,108 @@
 
 ---++ basicInitialize()
 
-Sets up POSIX locale and precompiled regexes - for use from scripts
-that handle multiple webs (e.g. mailnotify) and need regexes or
-isWebName/isWikiName to work before the per-web initialize() is called.
+Sets up basic stuff - for use from scripts
+that require the BEGIN block of this class to be
+executed e.g. mailnotify and need regexes or
+isWebName/isWikiWord to work before the per-web initialize() is called.
 Also called from initialize() if not necessary beforehand.
 
 =cut
 
 sub basicInitialize() {
-    # Set up locale for internationalisation and pre-compile regexes
-    setupLocale();
-    setupRegexes();
-    
     $basicInitDone = 1;
 }
 
-=pod
-
----++ setupLocale()
-
-Run-time locale setup - If $useLocale is set, this function parses $siteLocale
-from TWiki.cfg and passes it to the POSIX::setLocale function to change TWiki's
-operating environment.
-
-mod_perl compatibility note: If TWiki is running under Apache, won't this play
-with the Apache process's locale settings too?  What effects would this have?
-
-Note that 'use locale' must be done in BEGIN block for regexes and sorting to
-work properly, although regexes can still work without this in
-'non-locale regexes' mode (see setupRegexes routine).
-
-=cut
-
-sub setupLocale {
- 
-    $siteCharset = 'ISO-8859-1';	# Default values if locale mis-configured
-    $siteLang = 'en';
-    $siteFullLang = 'en-us';
-
-    if ( $useLocale ) {
-	if ( not defined $siteLocale or $siteLocale !~ /[a-z]/i ) {
-	    writeWarning "Locale $siteLocale unset or has no alphabetic characters";
-	    return;
-	}
-	# Extract the character set from locale and use in HTML templates
-	# and HTTP headers
-	$siteLocale =~ m/\.([a-z0-9_-]+)$/i;
-	$siteCharset = $1 if defined $1;
-	$siteCharset =~ s/^utf8$/utf-8/i;	# For convenience, avoid overrides
-	$siteCharset =~ s/^eucjp$/euc-jp/i;
-
-	# Override charset - used when locale charset not supported by Perl
-	# conversion modules
-	$siteCharset = $siteCharsetOverride || $siteCharset;
-	$siteCharset = lc $siteCharset;
-
-	# Extract the default site language - ignores '@euro' part of
-	# 'fr_BE@euro' type locales.
-	$siteLocale =~ m/^([a-z]+)_([a-z]+)/i;
-	$siteLang = (lc $1) if defined $1;	# Not including country part
-	$siteFullLang = (lc "$1-$2" ) 		# Including country part
-		if defined $1 and defined $2;
-
-	# Set environment variables for grep 
-	$ENV{'LC_CTYPE'}= $siteLocale;
-
-	# Load POSIX for I18N support 
-	require POSIX;
-	import POSIX qw( locale_h LC_CTYPE );
-
-	# Set new locale
-	my $locale = setlocale(&LC_CTYPE, $siteLocale);
-	##writeDebug "New locale is $locale";
-    }
-}
-
-=pod
-
----++ setupRegexes()
-
-Set up pre-compiled regexes for use in rendering.  All regexes with
-unchanging variables in match should use the '/o' option, even if not in a
-loop, to help mod_perl, where the same code can be executed many times
-without recompilation.
-
-=cut
-
-sub setupRegexes {
-
-    # Build up character class components for use in regexes.
-    # Depends on locale mode and Perl version, and finally on
-    # whether locale-based regexes are turned off.
-    if ( not $useLocale or $] < 5.006 or not $localeRegexes ) {
-	# No locales needed/working, or Perl 5.005_03 or lower, so just use
-	# any additional national characters defined in TWiki.cfg
-	$regex{upperAlpha} = "A-Z$upperNational";
-	$regex{lowerAlpha} = "a-z$lowerNational";
-	$regex{numeric} = '\d';
-	$regex{mixedAlpha} = "$regex{upperAlpha}$regex{lowerAlpha}";
-    } else {
-	# Perl 5.6 or higher with working locales
-	$regex{upperAlpha} = "[:upper:]";
-	$regex{lowerAlpha} = "[:lower:]";
-	$regex{numeric} = "[:digit:]";
-	$regex{mixedAlpha} = "[:alpha:]";
-    }
-    $regex{mixedAlphaNum} = "$regex{mixedAlpha}$regex{numeric}";
-    $regex{lowerAlphaNum} = "$regex{lowerAlpha}$regex{numeric}";
-
-    # Compile regexes for efficiency and ease of use
-    # Note: qr// locks in regex modes (i.e. '-xism' here) - see Friedl
-    # book at http://regex.info/. 
-
-    # TWiki concept regexes
-    $regex{wikiWordRegex} = qr/[$regex{upperAlpha}]+[$regex{lowerAlpha}]+[$regex{upperAlpha}]+[$regex{mixedAlphaNum}]*/;
-    $regex{webNameRegex} = qr/[$regex{upperAlpha}]+[$regex{mixedAlphaNum}]*/;
-    $regex{defaultWebNameRegex} = qr/_[$regex{mixedAlphaNum}_]+/;
-    $regex{anchorRegex} = qr/\#[$regex{mixedAlphaNum}_]+/;
-    $regex{abbrevRegex} = qr/[$regex{upperAlpha}]{3,}s?\b/;
-
-    # Simplistic email regex, e.g. for WebNotify processing - no i18n
-    # characters allowed
-    $regex{emailAddrRegex} = qr/([A-Za-z0-9\.\+\-\_]+\@[A-Za-z0-9\.\-]+)/;
-
-    # Filename regex, for attachments
-    $regex{filenameRegex} = qr/[$regex{mixedAlphaNum}\.]+/;
-
-    # Single-character alpha-based regexes
-    $regex{singleUpperAlphaRegex} = qr/[$regex{upperAlpha}]/;
-    $regex{singleLowerAlphaRegex} = qr/[$regex{lowerAlpha}]/;
-    $regex{singleUpperAlphaNumRegex} = qr/[$regex{upperAlpha}$regex{numeric}]/;
-    $regex{singleMixedAlphaNumRegex} = qr/[$regex{upperAlpha}$regex{lowerAlpha}$regex{numeric}]/;
-
-    $regex{singleMixedNonAlphaRegex} = qr/[^$regex{upperAlpha}$regex{lowerAlpha}]/;
-    $regex{singleMixedNonAlphaNumRegex} = qr/[^$regex{upperAlpha}$regex{lowerAlpha}$regex{numeric}]/;
-
-    # Multi-character alpha-based regexes
-    $regex{mixedAlphaNumRegex} = qr/[$regex{mixedAlphaNum}]*/;
-
-    # Character encoding regexes
-
-    # 7-bit ASCII only
-    $regex{validAsciiStringRegex} = qr/^[\x00-\x7F]+$/;
-    
-    # Regex to match only a valid UTF-8 character, taking care to avoid
-    # security holes due to overlong encodings by excluding the relevant
-    # gaps in UTF-8 encoding space - see 'perldoc perlunicode', Unicode
-    # Encodings section.  Tested against Markus Kuhn's UTF-8 test file
-    # at http://www.cl.cam.ac.uk/~mgk25/ucs/examples/UTF-8-test.txt.
-    $regex{validUtf8CharRegex} = qr{
-				# Single byte - ASCII
-				[\x00-\x7F] 
-				|
-
-				# 2 bytes
-				[\xC2-\xDF][\x80-\xBF] 
-				|
-
-				# 3 bytes
-
-				    # Avoid illegal codepoints - negative lookahead
-				    (?!\xEF\xBF[\xBE\xBF])	
-
-				    # Match valid codepoints
-				    (?:
-					([\xE0][\xA0-\xBF])|
-					([\xE1-\xEC\xEE-\xEF][\x80-\xBF])|
-					([\xED][\x80-\x9F])
-				    )
-				    [\x80-\xBF]
-				|
-
-				# 4 bytes 
-				    (?:
-					([\xF0][\x90-\xBF])|
-					([\xF1-\xF3][\x80-\xBF])|
-					([\xF4][\x80-\x8F])
-				    )
-				    [\x80-\xBF][\x80-\xBF]
-			    }x;
-
-    $regex{validUtf8StringRegex} = qr/^ (?: $regex{validUtf8CharRegex} )+ $/x;
-
-}
-
-=pod
-
----++ invalidSiteCharset()
-Return value: boolean $isCharsetInvalid
-
-Check for unusable multi-byte encodings as site character set
-- anything that enables a single ASCII character such as '[' to be
-matched within a multi-byte character cannot be used for TWiki.
-
-=cut
-
-sub invalidSiteCharset {
+# Return value: boolean $isCharsetInvalid
+# Check for unusable multi-byte encodings as site character set
+# - anything that enables a single ASCII character such as '[' to be
+# matched within a multi-byte character cannot be used for TWiki.
+sub _invalidSiteCharset {
     # FIXME: match other problematic multi-byte character sets 
     return ( $siteCharset =~ /^(?:iso-2022-?|hz-?|.*big5|.*shift_?jis|ms.kanji)/i );
 }
 
-
 =pod
 
 ---++ convertUtf8URLtoSiteCharset( $webName, $topicName )
 Return value: ( string $convertedWebName, string $convertedTopicName)
 Auto-detect UTF-8 vs. site charset in URL, and convert UTF-8 into site charset.
 
-TODO: remove dependence on webname and topicname, i.e. generic encoding
-subroutine.
+TODO: remove dependence on webname and topicname.
 
 =cut
 
 sub convertUtf8URLtoSiteCharset {
     my ( $webName, $topicName ) = @_;
 
-    ##writeDebug "URL web.topic is $webName.$topicName";
     my $fullTopicName = "$webName.$topicName";
     my $charEncoding;
 
     # Detect character encoding of the full topic name from URL
     if ( $fullTopicName =~ $regex{validAsciiStringRegex} ) {
-	$urlCharEncoding = 'ASCII';
+        $urlCharEncoding = 'ASCII';
     } elsif ( $fullTopicName =~ $regex{validUtf8StringRegex} ) {
-	$urlCharEncoding = 'UTF-8';
+        $urlCharEncoding = 'UTF-8';
 
-	# Convert into ISO-8859-1 if it is the site charset
-	if ( $siteCharset =~ /^iso-?8859-?1$/i ) {
-	    # ISO-8859-1 maps onto first 256 codepoints of Unicode
-	    # (conversion from 'perldoc perluniintro')
-	    $fullTopicName =~ s/ ([\xC2\xC3]) ([\x80-\xBF]) / 
-				 chr( ord($1) << 6 & 0xC0 | ord($2) & 0x3F )
-				 /egx;
-	} elsif ( $siteCharset eq "utf-8" ) {
-	    # Convert into internal Unicode characters if on Perl 5.8 or higher.
-	    if( $] >= 5.008 ) {
-		require Encode;			# Perl 5.8 or higher only
-		$fullTopicName = Encode::decode("utf8", $fullTopicName);	# 'decode' into UTF-8
-	    } else {
-		writeWarning "UTF-8 not supported on Perl $] - use Perl 5.8 or higher.";
-	    }
-	    writeWarning "UTF-8 not yet supported as site charset - TWiki is likely to have problems";
-	} else {
-	    # Convert from UTF-8 into some other site charset
-	    writeDebug "Converting from UTF-8 to $siteCharset";
+        # Convert into ISO-8859-1 if it is the site charset
+        if ( $siteCharset =~ /^iso-?8859-?1$/i ) {
+            # ISO-8859-1 maps onto first 256 codepoints of Unicode
+            # (conversion from 'perldoc perluniintro')
+            $fullTopicName =~ s/ ([\xC2\xC3]) ([\x80-\xBF]) / 
+              chr( ord($1) << 6 & 0xC0 | ord($2) & 0x3F )
+                /egx;
+        } elsif ( $siteCharset eq "utf-8" ) {
+            # Convert into internal Unicode characters if on Perl 5.8 or higher.
+            if( $] >= 5.008 ) {
+                require Encode;			# Perl 5.8 or higher only
+                $fullTopicName = Encode::decode("utf8", $fullTopicName);	# 'decode' into UTF-8
+            } else {
+                writeWarning( "UTF-8 not supported on Perl $] - use Perl 5.8 or higher." );
+            }
+            writeWarning( "UTF-8 not yet supported as site charset - TWiki is likely to have problems" );
+        } else {
+            # Convert from UTF-8 into some other site charset
+            writeDebug( "Converting from UTF-8 to $siteCharset" );
 
-	    # Use conversion modules depending on Perl version
-	    if( $] >= 5.008 ) {
-		require Encode;			# Perl 5.8 or higher only
+            # Use conversion modules depending on Perl version
+            if( $] >= 5.008 ) {
+                require Encode;			# Perl 5.8 or higher only
                 import Encode qw(:fallbacks);
-		# Map $siteCharset into real encoding name
-		$charEncoding = Encode::resolve_alias( $siteCharset );
-		if( not $charEncoding ) {
-		    writeWarning "Conversion to \$siteCharset '$siteCharset' not supported, or name not recognised - check 'perldoc Encode::Supported'";
-		} else {
-		    ##writeDebug "Converting with Encode, valid 'to' encoding is '$charEncoding'";
-		    # Convert text using Encode:
-		    # - first, convert from UTF8 bytes into internal (UTF-8) characters
-		    $fullTopicName = Encode::decode("utf8", $fullTopicName);	
-		    # - then convert into site charset from internal UTF-8,
-		    # inserting \x{NNNN} for characters that can't be converted
+                # Map $siteCharset into real encoding name
+                $charEncoding = Encode::resolve_alias( $siteCharset );
+                if( not $charEncoding ) {
+                    writeWarning( "Conversion to \$siteCharset '$siteCharset' not supported, or name not recognised - check 'perldoc Encode::Supported'" );
+                } else {
+                    ##writeDebug "Converting with Encode, valid 'to' encoding is '$charEncoding'";
+                    # Convert text using Encode:
+                    # - first, convert from UTF8 bytes into internal (UTF-8) characters
+                    $fullTopicName = Encode::decode("utf8", $fullTopicName);	
+                    # - then convert into site charset from internal UTF-8,
+                    # inserting \x{NNNN} for characters that can't be converted
                     $fullTopicName = Encode::encode( $charEncoding, $fullTopicName, &FB_PERLQQ() );
-		    ##writeDebug "Encode result is $fullTopicName";
-		}
-
-	    } else {
-		require Unicode::MapUTF8;	# Pre-5.8 Perl versions
-		$charEncoding = $siteCharset;
-		if( not Unicode::MapUTF8::utf8_supported_charset($charEncoding) ) {
-		    writeWarning "Conversion to \$siteCharset '$siteCharset' not supported, or name not recognised - check 'perldoc Unicode::MapUTF8'";
-		} else {
-		    # Convert text
-		    ##writeDebug "Converting with Unicode::MapUTF8, valid encoding is '$charEncoding'";
-		    $fullTopicName = Unicode::MapUTF8::from_utf8({ 
-			    			-string => $fullTopicName, 
-		    			 	-charset => $charEncoding });
-		    # FIXME: Check for failed conversion?
-		}
-	    }
-	}
-	($webName, $topicName) = split /\./, $fullTopicName;
-
+                    ##writeDebug "Encode result is $fullTopicName";
+                }
+            } else {
+                require Unicode::MapUTF8;	# Pre-5.8 Perl versions
+                $charEncoding = $siteCharset;
+                if( not Unicode::MapUTF8::utf8_supported_charset($charEncoding) ) {
+                    writeWarning( "Conversion to \$siteCharset '$siteCharset' not supported, or name not recognised - check 'perldoc Unicode::MapUTF8'" );
+                } else {
+                    # Convert text
+                    ##writeDebug "Converting with Unicode::MapUTF8, valid encoding is '$charEncoding'";
+                    $fullTopicName = Unicode::MapUTF8::from_utf8({ 
+                                                                  -string => $fullTopicName, 
+                                                                  -charset => $charEncoding });
+                    # FIXME: Check for failed conversion?
+                }
+            }
+        }
+        ($webName, $topicName) = split /\./, $fullTopicName;
     } else {
-	# Non-ASCII and non-UTF-8 - assume in site character set, 
-	# no conversion required
-	$urlCharEncoding = 'Native';
-	$charEncoding = $siteCharset;
+        # Non-ASCII and non-UTF-8 - assume in site character set, 
+        # no conversion required
+        $urlCharEncoding = 'Native';
+        $charEncoding = $siteCharset;
     }
     ##writeDebug "Final web and topic are $webName $topicName ($urlCharEncoding URL -> $siteCharset)";
 
@@ -779,19 +744,17 @@
 
 =cut
 
-sub writeHeader
-{
-    my( $query ) = @_;
+sub writeHeader {
+    my( $query, $contentLength ) = @_;
 
-    # FIXME: Pass real content-length to make persistent connections work
-    # in HTTP/1.1 (performance improvement for browsers and servers). 
-    # Requires significant but easy changes in various places.
+    # Pass real content-length to make persistent connections work
+    # in HTTP/1.1 (performance improvement for browsers and servers)
+    $contentLength = 0 unless defined( $contentLength );
 
     # Just write a basic content-type header for text/html
-    writeHeaderFull( $query, 'basic', 'text/html', 0);
+    writeHeaderFull( $query, 'basic', 'text/html', $contentLength);
 }
 
-
 =pod
 
 ---++ writeHeaderFull( $query, $pageType, $contentType, $contentLength )
@@ -815,8 +778,7 @@
 
 =cut
 
-sub writeHeaderFull
-{
+sub writeHeaderFull {
     my( $query, $pageType, $contentType, $contentLength ) = @_;
 
     # Handle Edit pages - future versions will extend to caching
@@ -842,7 +804,7 @@
 	# Set content length, to enable HTTP/1.1 persistent connections 
 	# (aka HTTP keepalive), and cache control headers, to ensure edit page 
 	# is cached until required expiry time.
-	$coreHeaders = $query->header( 
+	$coreHeaders = $query->header(
 			    -content_type => $contentType,
 			    -content_length => $contentLength,
 			    -last_modified => $lastModifiedString,
@@ -854,15 +816,14 @@
 	    		    -content_type => $contentType,
 			 );
     } else {
-	writeWarning( "===== invalid page type in TWiki.pm, writeHeaderFull(): $pageType" );
+	writeWarning( "Invalid page type in TWiki.pm, writeHeaderFull(): $pageType" );
     }
 
     # Delete extra CR/LF to allow suffixing more headers
     $coreHeaders =~ s/\r\n\r\n$/\r\n/s;
-    ##writeDebug( "===== After trim, Headers are:\n$coreHeaders" );
 
     # Wiki Plugin Hook - get additional headers from plugin
-    $pluginHeaders = &TWiki::Plugins::writeHeaderHandler( $query ) || '';
+    $pluginHeaders = TWiki::Plugins::writeHeaderHandler( $query ) || '';
 
     # Delete any trailing blank line
     $pluginHeaders =~ s/\r\n\r\n$/\r\n/s;
@@ -875,7 +836,6 @@
 	for $headerLine (split /\r\n/, $coreHeaders) {
 	    $headerLine =~ m/^([^ ]+): /i;		# Get header name
 	    $headerName = lc($1);
-	    ##writeDebug("==== core header name $headerName");
 	    $coreHeaderSeen{$headerName}++;
 	}
 	# Append plugin headers if legal and not seen in core headers
@@ -883,8 +843,6 @@
 	    $headerLine =~ m/^([^ ]+): /i;		# Get header name
 	    $headerName = lc($1);
 	    if ( $headerName =~ m/[\-a-z]+/io ) {	# Skip bad headers
-		##writeDebug("==== plugin header name $headerName");
-		##writeDebug("Saw $headerName already ") if $coreHeaderSeen{$headerName};
 		$finalHeaders .= $headerLine . "\r\n"
 		    unless $coreHeaderSeen{$headerName};
 	    }
@@ -893,54 +851,19 @@
     }
     $finalHeaders .= "\r\n" if ( $finalHeaders);
 
-    ##writeDebug( "===== Final Headers are:\n$finalHeaders" );
     print $finalHeaders;
-
 }
 
 =pod
 
----++ setPageMode( $mode )
-
-Set page rendering mode:
-   * 'rss' - encode 8-bit characters as XML entities
-   * 'html' - (default) no encoding of 8-bit characters
-   
-=cut
-
-sub setPageMode
-{
-    $pageMode = shift;
-}
-
-=pod
-
----++ getPageMode()
-Return value: string $mode
-
-Returns current page mode, 'html' unless set via setPageMode
-FIXME: This function is currently unused.  Remove on some non
-documentation-only commit, unless use is planned in future.
-
-=cut
-
-sub getPageMode
-{
-    return $pageMode;
-}
-
-=pod
-
 ---++ getCgiQuery()
-Retrun value: string $query
+Return value: string $query
 
-Returns the CGI query portion (i.e. the bit after the '?') of the
-current request.
+Returns the CGI query object for the current request. See =perldoc CGI=
 
 =cut
 
-sub getCgiQuery
-{
+sub getCgiQuery {
     return $cgiQuery;
 }
 
@@ -949,395 +872,96 @@
 ---++ redirect( $query, $url )
 
 Redirects the request to $url, via the CGI module object $query unless
-overridden by a plugin.  Note that this is currently only called by
-Func::redirectCgiQuery() at the request of a plugin!  All of the redirects
-done internally by TWiki are not overridable.
+overridden by a plugin declaring a =redirectCgiQueryHandler=.
 
 =cut
 
-sub redirect
-{
+sub redirect {
     my( $query, $url ) = @_;
-    if( ! &TWiki::Plugins::redirectCgiQueryHandler( $query, $url ) ) {
+    if( ! TWiki::Plugins::redirectCgiQueryHandler( $query, $url ) ) {
         print $query->redirect( $url );
     }
 }
 
-
 =pod
 
----++ getEmailNotifyList( $webName, $topicName )
-Return value: @emailNotifyList
+---++ isValidWikiWord (  $name  )
+Check for a valid WikiWord or WikiName
 
-Get email list from WebNotify page - this now handles entries of the form:
-   * Main.UserName 
-   * UserName 
-   * Main.GroupName
-   * GroupName
-The 'UserName' format (i.e. no Main webname) is supported in any web, but
-is not recommended since this may make future data conversions more
-complicated, especially if used outside the Main web.  %<nop>MAINWEB% is OK
-instead of 'Main'.  The user's email address(es) are fetched from their
-user topic (home page) as long as they are listed in the '* Email:
-fred@example.com' format.  Nested groups are supported.
-
 =cut
 
-sub getEmailNotifyList
-{
-    my( $web, $topicname ) = @_;
+sub isValidWikiWord {
+    my( $name ) = @_;
 
-    $topicname = $notifyTopicname unless $topicname;
-    return() unless &TWiki::Store::topicExists( $web, $topicname );
-
-    # Allow %MAINWEB% as well as 'Main' in front of users/groups -
-    # non-capturing regex.
-    my $mainWebPattern = qr/(?:$mainWebname|%MAINWEB%)/;
-
-    my @list = ();
-    my %seen;			# Incremented when email address is seen
-    foreach ( split ( /\n/, TWiki::Store::readWebTopic( $web, $topicname ) ) ) {
-        if ( /^\s+\*\s(?:$mainWebPattern\.)?($regex{wikiWordRegex})\s+\-\s+($regex{emailAddrRegex})/o ) {
-	    # Got full form:   * Main.WikiName - email@domain
-	    # (the 'Main.' part is optional, non-capturing)
-	    if ( $1 ne 'TWikiGuest' ) {
-		# Add email address to list if non-guest and non-duplicate
-		push (@list, $2) unless $seen{$1}++;
-            }
-        } elsif ( /^\s+\*\s(?:$mainWebPattern\.)?($regex{wikiWordRegex})\s*$/o ) { 
-	    # Got short form:   * Main.WikiName
-	    # (the 'Main.' part is optional, non-capturing)
-            my $userWikiName = $1;
-            foreach ( getEmailOfUser($userWikiName) ) {
-		# Add email address to list if it's not a duplicate
-                push (@list, $_) unless $seen{$_}++;
-            }
-        }
-    }
-    ##writeDebug "list of emails: @list";
-    return( @list);
+    $name ||= "";	# Default value if undef
+    return ( $name =~ m/^$regex{wikiWordRegex}$/o )
 }
 
 =pod
 
----++ getEmailOfUser( $wikiName )
-Return value: ( $userEmail ) or @groupEmailList
+---++ isValidTopicName (  $name  )
+Check for a valid topic name
 
-Get e-mail address for a given WikiName from the user's home page, or
-list of e-mail addresses for a group.  Nested groups are supported.
-$wikiName must contain _only_ the WikiName; do *not* pass names of the
-form "Main.JohnSmith".
-
 =cut
 
-sub getEmailOfUser
-{
-    my( $wikiName ) = @_;		# WikiName without web prefix
-
-    my @list = ();
-    # Ignore guest entry and non-existent pages
-    if ( $wikiName ne "TWikiGuest" && 
-		TWiki::Store::topicExists( $mainWebname, $wikiName ) ) {
-        if ( $wikiName =~ /Group$/ ) {
-            # Page is for a group, get all users in group
-	    ##writeDebug "using group: $mainWebname . $wikiName";
-	    my @userList = TWiki::Access::getUsersOfGroup( $wikiName ); 
-	    foreach my $user ( @userList ) {
-		$user =~ s/^.*\.//;	# Get rid of 'Main.' part.
-		foreach my $email ( getEmailOfUser($user) ) {
-		    push @list, $email;
-		}
-	    }
-        } else {
-	    # Page is for a user
-	    ##writeDebug "reading home page: $mainWebname . $wikiName";
-            foreach ( split ( /\n/, &TWiki::Store::readWebTopic( 
-					    $mainWebname, $wikiName ) ) ) {
-                if (/^\s\*\sEmail:\s+([\w\-\.\+]+\@[\w\-\.\+]+)/) {   
-		    # Add email address to list
-                    push @list, $1;
-                }
-            }
-        }
-    }
-    return (@list);
-}
-
-=pod
-
----++ initializeRemoteUser( $remoteUser )
-Return value: $remoteUser
-
-Acts as a filter for $remoteUser.  If set, $remoteUser is filtered for
-insecure characters and untainted.
-
-If $doRememberRemoteUser and $remoteUser are both set, it also caches
-$remoteUser as belonging to the IP address of the current request.
-
-If $doRememberRemoteUser is set and $remoteUser is not, then it sets
-$remoteUser to the last authenticated user to make a request with the
-current request's IP address, or $defaultUserName if no cached name
-is available.
-
-If neither are set, then it sets $remoteUser to $defaultUserName.
-
-=cut
-
-sub initializeRemoteUser
-{
-    my( $theRemoteUser ) = @_;
-
-    my $remoteUser = $theRemoteUser || $defaultUserName;
-    $remoteUser =~ s/$securityFilter//go;
-    $remoteUser =~ /(.*)/;
-    $remoteUser = $1;  # untaint variable
-
-    my $remoteAddr = $ENV{'REMOTE_ADDR'} || "";
-
-    if( $ENV{'REDIRECT_STATUS'} && $ENV{'REDIRECT_STATUS'} eq '401' ) {
-        # bail out if authentication failed
-        $remoteAddr = "";
-    }
-
-    if( ( ! $doRememberRemoteUser ) || ( ! $remoteAddr ) ) {
-        # do not remember IP address
-        return $remoteUser;
-    }
-
-    my $text = &TWiki::Store::readFile( $remoteUserFilename );
-    # Assume no I18N characters in userids, as for email addresses
-    # FIXME: Needs fixing for IPv6?
-    my %AddrToName = map { split( /\|/, $_ ) }
-                     grep { /^[0-9\.]+\|[A-Za-z0-9]+\|$/ }
-                     split( /\n/, $text );
-
-    my $rememberedUser = "";
-    if( exists( $AddrToName{ $remoteAddr } ) ) {
-        $rememberedUser = $AddrToName{ $remoteAddr };
-    }
-
-    if( $theRemoteUser ) {
-        if( $theRemoteUser ne $rememberedUser ) {
-            $AddrToName{ $remoteAddr } = $theRemoteUser;
-            # create file as "$remoteAddr|$theRemoteUser|" lines
-            $text = "# This is a generated file, do not modify.\n";
-            foreach my $usrAddr ( sort keys %AddrToName ) {
-                my $usrName = $AddrToName{ $usrAddr };
-                # keep $userName unique
-                if(  ( $usrName ne $theRemoteUser )
-                  || ( $usrAddr eq $remoteAddr ) ) {
-                    $text .= "$usrAddr|$usrName|\n";
-                }
-            }
-            &TWiki::Store::saveFile( $remoteUserFilename, $text );
-        }
-    } else {
-        # get user name from AddrToName table
-        $remoteUser = $rememberedUser || $defaultUserName;
-    }
-
-    return $remoteUser;
-}
-
-=pod
-
----++ userToWikiListInit()
-
-Build hashes to translate in both directions between username (e.g. jsmith) 
-and WikiName (e.g. JaneSmith).  Only used for sites where authentication is
-managed by external Apache configuration, instead of via TWiki's .htpasswd
-mechanism.
-
-=cut
-
-sub userToWikiListInit
-{
-    %userToWikiList = ();
-    %wikiToUserList = ();
-    my @list = ();
-    if( $doMapUserToWikiName ) {
-        @list = split( /\n/, TWiki::Store::readFile( $userListFilename ) );
-    } else {
-        # fix for Codev.SecurityAlertGainAdminRightWithTWikiUsersMapping
-        # for .htpasswd authenticated sites ignore user list, but map only guest to TWikiGuest
-        @list = ( "\t* TWikiGuest - guest - " ); # CODE_SMELL on localization
-    }
-
-    # Get all entries with two '-' characters on same line, i.e.
-    # 'WikiName - userid - date created'
-    @list = grep { /^\s*\* $regex{wikiWordRegex}\s*-\s*[^\-]*-/o } @list;
-    my $wUser;
-    my $lUser;
-    foreach( @list ) {
-	# Get the WikiName and userid, and build hashes in both directions
-        if(  ( /^\s*\* ($regex{wikiWordRegex})\s*\-\s*([^\s]*).*/o ) && $2 ) {
-            $wUser = $1;	# WikiName
-            $lUser = $2;	# userid
-            $lUser =~ s/$securityFilter//go;	# FIXME: Should filter in for security...
-            $userToWikiList{ $lUser } = $wUser;
-            $wikiToUserList{ $wUser } = $lUser;
-        }
-    }
-}
-
-=pod
-
----++ userToWikiName( $loginUser, $dontAddWeb )
-Return value: $wikiName
-
-Translates intranet username (e.g. jsmith) to WikiName (e.g. JaneSmith)
-userToWikiListInit must be called before this function is used.
-
-Unless $dontAddWeb is set, "Main." is prepended to the returned WikiName.
-
-if you give an invalid username, we just return that (no appending Main. blindy)
-
-SMELL: the userToWikiList cache should really contain the WebName so its possible 
-		to have userTopics in more than just the MainWeb (what if you move a user topic?)
-
-=cut
-
-sub userToWikiName
-{
-    my( $loginUser, $dontAddWeb ) = @_;
-    
-    if( !$loginUser ) {
-        return "";
-    }
-
-    $loginUser =~ s/$securityFilter//go;
-    my $wUser = $userToWikiList{ $loginUser } || $loginUser;
-    if( $dontAddWeb ) {
-        return $wUser;
-    }
-    return "$mainWebname.$wUser";
-}
-
-=pod
-
----++ wikiToUserName( $wikiName )
-Return value: $loginUser
-
-Translates WikiName (e.g. JaneSmith) to an intranet username (e.g. jsmith)
-userToWikiListInit must be called before this function is used.
-
-=cut
-
-sub wikiToUserName
-{
-    my( $wikiUser ) = @_;
-    $wikiUser =~ s/^.*\.//g;
-    my $userName =  $wikiToUserList{"$wikiUser"} || $wikiUser;
-    ##writeDebug( "TWiki::wikiToUserName: $wikiUser->$userName" );
-    return $userName;
-}
-
-=pod
-
----++ isGuest()
-
-Returns whether the current user is TWikiGuest or equivalent.
-
-=cut
-
-sub isGuest
-{
-   return ( $userName eq $defaultUserName );
-}
-
-# =========================
-=pod
-
----++ sub getWikiUserTopic ()
-
-Not yet documented.
-
-=cut
-
-sub getWikiUserTopic
-{
-    # Topic without Web name
-    return $wikiName;
-}
-
-# =========================
-# Check for a valid WikiWord or WikiName
-=pod
-
----++ sub isWikiName (  $name  )
-
-Not yet documented.
-CODE_SMELL - this should be called isWikiWord
-
-=cut
-
-sub isWikiName
-{
+sub isValidTopicName {
     my( $name ) = @_;
 
-    $name ||= "";	# Default value if undef
-    return ( $name =~ m/^$regex{wikiWordRegex}$/o )
+    return isValidWikiWord( @_ ) || isValidAbbrev( @_ );
 }
 
-# =========================
-# Check for a valid ABBREV (acronym)
 =pod
 
----++ sub isAbbrev (  $name  )
+---++ isValidAbbrev (  $name  )
+Check for a valid ABBREV (acronym)
 
-Not yet documented.
-
 =cut
 
-sub isAbbrev
-{
+sub isValidAbbrev {
     my( $name ) = @_;
 
     $name ||= "";	# Default value if undef
     return ( $name =~ m/^$regex{abbrevRegex}$/o )
 }
 
-# =========================
-# Check for a valid web name
 =pod
 
----++ sub isWebName (  $name  )
+---++ isValidWebName (  $name  )
 
-Not yet documented.
+Check for a valid web name
 
 =cut
 
-sub isWebName
-{
+sub isValidWebName {
     my( $name ) = @_;
 
     $name ||= "";	# Default value if undef
     return ( $name =~ m/^$regex{webNameRegex}$/o )
 }
 
-# =========================
 =pod
 
----++ sub readOnlyMirrorWeb (  $theWeb  )
+---++ readOnlyMirrorWeb (  $theWeb  )
 
-Not yet documented.
+If this is a mirrored web, return information about the mirror. The info
+is returned in a quadruple:
+| site name | URL | link | note |
 
 =cut
 
-sub readOnlyMirrorWeb
-{
+sub readOnlyMirrorWeb {
     my( $theWeb ) = @_;
 
     my @mirrorInfo = ( "", "", "", "" );
     if( $siteWebTopicName ) {
-        my $mirrorSiteName = &TWiki::Prefs::getPreferencesValue( "MIRRORSITENAME", $theWeb );
+        my $mirrorSiteName = TWiki::Prefs::getPreferencesValue( "MIRRORSITENAME", $theWeb );
         if( $mirrorSiteName && $mirrorSiteName ne $siteWebTopicName ) {
-            my $mirrorViewURL  = &TWiki::Prefs::getPreferencesValue( "MIRRORVIEWURL", $theWeb );
-            my $mirrorLink = &TWiki::Store::readTemplate( "mirrorlink" );
+            my $mirrorViewURL  = TWiki::Prefs::getPreferencesValue( "MIRRORVIEWURL", $theWeb );
+            my $mirrorLink = TWiki::Store::readTemplate( "mirrorlink" );
             $mirrorLink =~ s/%MIRRORSITENAME%/$mirrorSiteName/g;
             $mirrorLink =~ s/%MIRRORVIEWURL%/$mirrorViewURL/g;
             $mirrorLink =~ s/\s*$//g;
-            my $mirrorNote = &TWiki::Store::readTemplate( "mirrornote" );
+            my $mirrorNote = TWiki::Store::readTemplate( "mirrornote" );
             $mirrorNote =~ s/%MIRRORSITENAME%/$mirrorSiteName/g;
             $mirrorNote =~ s/%MIRRORVIEWURL%/$mirrorViewURL/g;
             $mirrorNote = TWiki::Render::getRenderedVersion( $mirrorNote, $theWeb );
@@ -1348,51 +972,8 @@
     return @mirrorInfo;
 }
 
-
-# =========================
 =pod
 
----++ sub getDataDir ()
-
-Not yet documented.
-
-=cut
-
-sub getDataDir
-{
-    return $dataDir;
-}
-
-# =========================
-=pod
-
----++ sub getPubDir ()
-
-Not yet documented.
-
-=cut
-
-sub getPubDir
-{
-    return $pubDir;
-}
-
-# =========================
-=pod
-
----++ sub getPubUrlPath ()
-
-Not yet documented.
-
-=cut
-
-sub getPubUrlPath
-{
-    return $pubUrlPath;
-}
-
-=pod
-
 ---++ getTWikiLibDir()
 
 If necessary, finds the full path of the directory containing TWiki.pm,
